/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.URL;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import objets.CElementBase;
import objets.CListeObjets;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ChoixObjetsSourcesPourConstDlg extends MtgDlg {
	private JLabel label1, label2;
	private ListeObjetsNumeriquesSourcesPourConst listeDispo, listeChoisie;
	private JScrollPane scrollPaneListeDispo, scrollPaneListeChoisie;
	private JButton btnOK, btnCancel;
	private JButton btnInserer, btnInsererFin, btnInsererDebut, btnRetirer, btnRetirerTout;
	private JButton btnHaut;
	private JButton btnBas;
	private MtgFocusTraversalPolicy mtgFocusTraversalPolicy;
	
	/**
	 *  Constructeur
	 * @param frameInit
	 */
	public ChoixObjetsSourcesPourConstDlg(MtgFrame frameInit) {
		super(getString("choixObjetsSourcesPourConstDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);
    listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
    pack();
	}
	
  private void initComponents() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
		label1 = new JLabel(getString("choixObjetsSourcesPourConstDlg2"));
		label2 = new JLabel(getString("choixObjetsSourcesPourConstDlg3"));
		listeDispo = new ListeObjetsNumeriquesSourcesPourConst(liste, cadre.listeObjetsSourcesNG, liste.size() - 1);
    listeDispo.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent evt) {
				listeDispoMouseClicked(evt);
			}

			public void mouseEntered(MouseEvent evt) {
			}

			public void mouseExited(MouseEvent evt) {
			}

			public void mousePressed(MouseEvent evt) {
			}

			public void mouseReleased(MouseEvent evt) {
			}
    });    
    scrollPaneListeDispo = new JScrollPane(listeDispo, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
    		JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );	
		listeChoisie = new ListeObjetsNumeriquesSourcesPourConst(cadre.listeObjetsSourcesNG);

    scrollPaneListeChoisie = new JScrollPane(listeChoisie, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
    		JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );
	  btnInserer = new javax.swing.JButton(getString("btnInserer"));
	  btnInserer.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnInsererActionPerformed();
	    }
	  });        
	  btnInsererDebut = new javax.swing.JButton(getString("btnInsererDebut"));
	  btnInsererDebut.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnInsererDebutActionPerformed();
	    }
	  });        
	  btnInsererFin = new javax.swing.JButton(getString("btnInsererFin"));
	  btnInsererFin.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnInsererFinActionPerformed();
	    }
	  });        
	  btnRetirer = new javax.swing.JButton(getString("btnRetirer"));
	  btnRetirer.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnRetirerActionPerformed();
	    }
	  });        
	  btnRetirerTout = new javax.swing.JButton(getString("btnRetirerTout"));
	  btnRetirerTout.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnRetirerToutActionPerformed();
	    }
	  });
	  btnRetirer.setPreferredSize(btnRetirerTout.getPreferredSize());
	  Dimension size1 = btnInsererDebut.getPreferredSize();
	  Dimension size2 = btnInsererFin.getPreferredSize();
	  if (size1.width >= size2.width) {
	  	btnInsererFin.setPreferredSize(size1);
	  	btnInserer.setPreferredSize(size1);
	  }
	  else {
	  	btnInsererDebut.setSize(size2);
	  	btnInserer.setSize(size2);
	  }
	  
	  btnOK = new javax.swing.JButton(getString("btnOK"));
	  btnOK.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnOKActionPerformed();
	    }
	  });    
	  btnCancel = new javax.swing.JButton(getString("btnCancel"));
	  btnCancel.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnCancelActionPerformed();
	    }
	  });
	  btnOK.setMaximumSize(btnCancel.getPreferredSize());
    URL adr = MtgFrame.class.getResource("images/Up16.gif");    
    btnHaut = new JButton(new ImageIcon(adr));
	  btnHaut.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnHautActionPerformed();
	    }
	  });	  
    adr = MtgFrame.class.getResource("images/Down16.gif");    
    btnBas = new JButton(new ImageIcon(adr));
	  btnBas.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnBasActionPerformed();
	    }
	  });
	  
    JPanel panePrincipal = new JPanel();
    panePrincipal.setLayout(new GridBagLayout());
    JPanel paneRight = new JPanel();
    JPanel paneBoutonsHautBas = new JPanel();
    paneBoutonsHautBas.setLayout(new BoxLayout(paneBoutonsHautBas, BoxLayout.Y_AXIS));
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 2;
		constraints.insets.top = 2;
		constraints.insets.left = 5;
		constraints.insets.right = 5;
		
		paneBoutonsHautBas.add(btnHaut);
    paneBoutonsHautBas.add(Box.createRigidArea(new Dimension(0,5)));
		paneBoutonsHautBas.add(btnBas);

		// paneMilieu est le JPanel contenant les deux listes de macros et les boutons correspondants
		setConstraints(constraints, 0, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label1, constraints);
		setConstraints(constraints, 0, 1, 1, 1, 0, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
		panePrincipal.add(scrollPaneListeDispo, constraints);
		setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label2, constraints);
		setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
		panePrincipal.add(scrollPaneListeChoisie, constraints);
		setConstraints(constraints, 0, 2, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnInserer, constraints);
		setConstraints(constraints, 0, 3, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnInsererDebut, constraints);
		setConstraints(constraints, 0, 4, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnInsererFin, constraints);
		setConstraints(constraints, 1, 2, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnRetirer, constraints);
		setConstraints(constraints, 1, 3, 1, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnRetirerTout, constraints);
		setConstraints(constraints, 2, 0, 1, 2, 10, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(paneBoutonsHautBas, constraints);
		
 		setConstraints(constraints, 3, 0, 1, 2, 20, 0, GridBagConstraints.BOTH, GridBagConstraints.WEST);
		panePrincipal.add(paneRight, constraints);
		
		setContentPane(panePrincipal);
		// On change l'ordre par dfaut des composants
		Vector<Component> order = new Vector<Component>(4);
		order.add(listeDispo);
		order.add(listeChoisie);
		order.add(btnOK);
		order.add(btnCancel);
		mtgFocusTraversalPolicy = new MtgFocusTraversalPolicy(order);
		setFocusTraversalPolicy(mtgFocusTraversalPolicy);
  }
  
  // Modification version 4.2 : on ne peut pas insrer un lement comme source
  // s'il dpend d'un des objets dj choisis ou si un objet dj choisi en dpend
  private void btnInsererActionPerformed() {
  	CElementBase el = listeDispo.elementChoisi();
  	if (el != null) {
	  	if (listeChoisie.getSelectedIndex() == -1) listeChoisie.insereValeurFin(el);
	  	else listeChoisie.insereValeur(el);
	  	// listeDispo.retireValeurSelectionneePourDispo();
	  	listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
  	}
  }
  	
  private void btnInsererDebutActionPerformed() {
  	CElementBase el = listeDispo.elementChoisi();
  	if (el != null) {
	  	listeChoisie.insereValeurDebut(el);
	  	// listeDispo.retireValeurSelectionneePourDispo();
	  	listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
  	}
  }
  
  private void btnInsererFinActionPerformed() {
	  CElementBase el = listeDispo.elementChoisi();
  	if (el != null) {
	  	listeChoisie.insereValeurFin(el);
	  	// listeDispo.retireValeurSelectionneePourDispo();
	  	listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
  	}
  }
  
  private void btnRetirerActionPerformed() {
  	listeChoisie.retireValeurSelectionnee();
  	listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
  }
  
  private void btnRetirerToutActionPerformed() {
  	listeChoisie.retireTout();
  	listeDispo.metAJourListe(listeChoisie, frame.cadreActif().listeObjetsSourcesG);
  }
  
  private void btnOKActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	cadre.listeObjetsSourcesNG.retireTout();
  	int nb = listeChoisie.pointeurs.size();
  	for (int i = 0; i < nb; i++) {
  		CElementBase elb = listeChoisie.pointeurs.get(i); // elb peut pointer soit sur un CValeurDynamique soit sur un CRepere
  		cadre.listeObjetsSourcesNG.add(elb);
  	}
  	setRetourOK(true);
  	dispose();  	  	
  }
  
  private void btnCancelActionPerformed() {
  	dispose();
  }
  
  private void btnHautActionPerformed() {
  	listeChoisie.decaleBasValeurSelectionnee();
  }
  
  private void btnBasActionPerformed() {
  	listeChoisie.decaleHautValeurSelectionnee();
  }
  
  public void listeDispoMouseClicked(MouseEvent evt) {
		if (evt.getClickCount() == 2) btnInsererFinActionPerformed() ;
  }
  
}
