package dialogs;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.ListIterator;
import java.util.Vector;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementBase;
import objets.CListeObjets;
import objets.CVariableBornee;
import types.NatureCalcul;

@SuppressWarnings("serial")
public class PaneAffichageVariables extends JScrollPane implements MouseMotionListener {
	private MtgInternalFrame cadre;
	private Vector<PaneVariablePourDlg> table = new Vector<PaneVariablePourDlg>(); // Tableau des panneaux d'affichage de variable
	private int hauteurPourUneVar;
	private int largeur;
	private JPanel panePrincipal;
	public PaneAffichageVariables(MtgInternalFrame cadreInit) {
		super(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		cadre = cadreInit;
		addMouseMotionListener(this);
		hauteurPourUneVar = 0;
		panePrincipal = new JPanel();
		panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.Y_AXIS));
		setViewportView(panePrincipal);
		
		CListeObjets liste = cadre.listePr;
		java.util.ListIterator<CElementBase> li = liste.listIterator();
		int nb = 0;
		while (li.hasNext()) {
			CElementBase elb = li.next();
			if (elb.getNatureCalcul() == NatureCalcul.NVariable) {
				CVariableBornee var = (CVariableBornee) elb;
				if (var.dialogueAssocie) {
					PaneVariablePourDlg pane = new PaneVariablePourDlg(cadre, var);
					panePrincipal.add(pane);
					table.add(pane);
					if (nb == 0) {
						hauteurPourUneVar = pane.getPreferredSize().height;
					}
					nb++;
				}
			}
		}
		largeur = getPreferredSize().width;
		hauteurPourUneVar ++; // Car sini la ligne du bas n'est pas entirement visible
		if (nb == 1) setPreferredSize(new Dimension(largeur, hauteurPourUneVar));
		else {
			if (nb == 2) setPreferredSize(new Dimension(largeur, 2*hauteurPourUneVar));
			else setPreferredSize(new Dimension(largeur, 3*hauteurPourUneVar));
		}
		// Appel seulement  la fin pour que la largeur soit correcte
		setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	}
	
	public void metAJourAffichageDe(CVariableBornee var) {
		ListIterator<PaneVariablePourDlg> li = table.listIterator();
		while (li.hasNext()) {
			PaneVariablePourDlg pane = li.next();
			if (pane.variableAssociee == var) {
				pane.metAJourValeur();
			}
		}
	}
	
	
	public void retireAffichageVariable(CVariableBornee var) {
		Component[] tabcomp = getComponents();
		for (int i = 0; i < tabcomp.length; i++) {
			if (tabcomp[i].getClass() == PaneVariablePourDlg.class) {
				PaneVariablePourDlg paneVar = (PaneVariablePourDlg) tabcomp[i];
				if (paneVar.variableAssociee == var) this.remove(paneVar);
			}
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	public void mouseMoved(MouseEvent e) {
		setCursor(MtgFrame.defaultCursor);
	}
}
