/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PaneBoutonsListeValeursEtFonctionsTextField extends JPanel {
	private MtgFrame frame;
	private JTextField editeur; // l'diteur associ
	private boolean calculsReels; // True si l'diteur attend une valeur relle
	public JButton btnListeValeurs, btnListeFonctionsPredefinies; // public version 4.5.2
	private int indiceMaxi; // Indice de la dernire valeur qui peut figurer dans la liste des valeurs
	private boolean intermPermis; // True si la liste des vzleurs doit prsenter les valeurs intermdiaires
	
	
	// Constructeur
	public PaneBoutonsListeValeursEtFonctionsTextField(MtgFrame frameInit, JTextField editeurInit,
			boolean calculsReelsInit, int indiceMaxiInit, boolean intermPermisInit) {
		super();
		frame = frameInit;
		editeur = editeurInit;
		calculsReels = calculsReelsInit;
		indiceMaxi = indiceMaxiInit;
		intermPermis = intermPermisInit;
    btnListeValeurs = new JButton(MtgFrame.getString("listeValeurs"));
    btnListeValeurs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeValeursActionPerformed();
      }
    });
    btnListeFonctionsPredefinies = new JButton(MtgFrame.getString("listeFonctions"));
    btnListeFonctionsPredefinies.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeFonctionsPredefiniesActionPerformed();
      }
    });    
    add(btnListeValeurs);
    add(Box.createRigidArea(new Dimension(6,0)));
    add (btnListeFonctionsPredefinies);
	}
	
	/**
	 * Constructeur ajoutant un bouton Valeurs si bValeurs est true et un bouton fonctions prdfinies
	 * si bFonctions est true
	 * @param appletInit
	 * @param editeurInit
	 * @param calculsReelsInit
	 * @param indiceMaxiInit
	 * @param intermPermisInit
	 */
	public PaneBoutonsListeValeursEtFonctionsTextField(MtgFrame frameInit, JTextField editeurInit,
			boolean calculsReelsInit, int indiceMaxiInit, boolean intermPermisInit, boolean bValeurs, boolean bFonctions) {
		super();
		frame = frameInit;
		editeur = editeurInit;
		calculsReels = calculsReelsInit;
		indiceMaxi = indiceMaxiInit;
		intermPermis = intermPermisInit;
    btnListeValeurs = new JButton(MtgFrame.getString("listeValeurs"));
    btnListeValeurs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeValeursActionPerformed();
      }
    });
    btnListeFonctionsPredefinies = new JButton(MtgFrame.getString("listeFonctions"));
    btnListeFonctionsPredefinies.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeFonctionsPredefiniesActionPerformed();
      }
    });    
    if (bValeurs) {
    	add(btnListeValeurs);
    	add(Box.createRigidArea(new Dimension(6,0)));
    }
    if (bFonctions) add (btnListeFonctionsPredefinies);
	}

	private void btnListeValeursActionPerformed() {
		if (calculsReels) {
			ListeValeursOuFonctionsReellesTextFieldDlg dlg = 
				new ListeValeursOuFonctionsReellesTextFieldDlg(frame, editeur, indiceMaxi, intermPermis);
			dlg.setLocationRelativeTo(frame); // Modifi version 4.7.5.2
			dlg.setVisible(true);
		}
		else {
			ListeValeursOuFonctionsReellesOuComplexesTextFieldDlg dlg = 
				new ListeValeursOuFonctionsReellesOuComplexesTextFieldDlg(frame, editeur, indiceMaxi, intermPermis);
			dlg.setLocationRelativeTo(frame); // Modifi version 4.7.5.2
			dlg.setVisible(true);
		}
	}
	
	private void btnListeFonctionsPredefiniesActionPerformed() {
		ListeFonctionsPredefiniesDlg dlg = new ListeFonctionsPredefiniesDlg(frame, editeur, calculsReels);
		dlg.setLocationRelativeTo(frame); // Modifi version 4.7.5.2
		dlg.setVisible(true);		
	}

	public void setEnabled(boolean bactivated) {
		btnListeValeurs.setEnabled(bactivated);
		btnListeFonctionsPredefinies.setEnabled(bactivated);
	}
}
