/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PaneFrequenceAnimation extends JPanel {
	public JList<String> listeFreq;
	private boolean maxPermis;
	public PaneFrequenceAnimation(int frequenceInit, boolean maxPermisInit) {
		super();
		maxPermis = maxPermisInit;
		listeFreq= new JList<String>();
		Vector<String> vec = new Vector<String>();
		if (maxPermis) vec.add(MtgFrame.getString("paneFrequenceAnimation2")); // Max
		vec.add("1/100");
		vec.add("2/100");
		vec.add("3/100");
		vec.add("4/100");
		vec.add("5/100");
		vec.add("1/10");
		vec.add("2/10");
		vec.add("3/10");
		vec.add("4/10");
		vec.add("5/10");
		vec.add("6/10");
		vec.add("7/10");
		vec.add("8/10");
		vec.add("9/10");
		vec.add("1");
		vec.add("1/1000");
		vec.add("2/1000");
		vec.add("3/1000");
		vec.add("4/1000");
		vec.add("5/1000");
		vec.add("6/1000");
		vec.add("7/1000");
		vec.add("8/1000");
		vec.add("9/1000");
		
		listeFreq.setListData(vec);
    listeFreq.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    listeFreq.setLayoutOrientation(JList.VERTICAL);
    listeFreq.setVisibleRowCount(5);
    int ind = indiceDeFrequence(frequenceInit);
    listeFreq.setSelectedIndex(ind);
    JLabel label1 = new JLabel(MtgFrame.getString("paneFrequenceAnimation3"));
    add(label1);
    JScrollPane scrollpane = new JScrollPane(listeFreq, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    listeFreq.ensureIndexIsVisible(ind);
    add(scrollpane);
    setBorder(BorderFactory.createTitledBorder(MtgFrame.getString("paneFrequenceAnimation1")));
	}
	
	public final int indiceDeFrequence(int freq) {
		if (maxPermis) {
			switch (freq) {
				case 0 : return 0;
				case 10 : return 1;
				case 20 : return 2;
				case 30 : return 3;
				case 40 : return 4;
				case 50 : return 5;
				case 1 : return 16;
				case 2 : return 17;
				case 3 : return 18;
				case 4 : return 19;
				case 5 : return 20;
				case 6 : return 21;
				case 7 : return 22;
				case 8 : return 23;
				case 9 : return 24;
				default : return 5 + freq/100;
			}
		}
		else {
			switch (freq) {
			case 10 : return 0;
			case 20 : return 1;
			case 30 : return 2;
			case 40 : return 3;
			case 50 : return 4;
			case 1 : return 15;
			case 2 : return 16;
			case 3 : return 17;
			case 4 : return 18;
			case 5 : return 19;
			case 6 : return 20;
			case 7 : return 21;
			case 8 : return 22;
			case 9 : return 23;
			default : return 4 + freq/100;
		}			
		}
	}
	
	public final int frequenceChoisie() {
		int ind = listeFreq.getSelectedIndex();
		if (maxPermis) {
			switch (ind) {
				case 0 : return 0;
				case 1 : return 10;
				case 2 : return 20;
				case 3 : return 30;
				case 4 : return 40;
				case 5 : return 50;
				case 16 : return 1;
				case 17 : return 2;
				case 18 : return 3;
				case 19 : return 4;
				case 20 : return 5;
				case 21 : return 6;
				case 22 : return 7;
				case 23 : return 8;
				case 24 : return 9;
				
				default : return 100*(ind - 5);
			}
		}
		else {
			switch (ind) {
			case 0 : return 10;
			case 1 : return 20;
			case 2 : return 30;
			case 3 : return 40;
			case 4 : return 50;
			case 15 : return 1;
			case 16 : return 2;
			case 17 : return 3;
			case 18 : return 4;
			case 19 : return 5;
			case 20 : return 6;
			case 21 : return 7;
			case 22 : return 8;
			case 23 : return 9;
			
			default : return 100*(ind - 4);
			}
		}
	}
}
