/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.FlowLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;

/** 
 * pane servant  afficher un choix de dcimales variant de 0  12
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class PaneListeDecimales extends JPanel {
	public JList<String> listeDec;
	private JScrollPane scrollpane;
	public PaneListeDecimales(int nombreDecimalesInit) {
		super();
		JLabel label1 = new JLabel(MtgFrame.getString("paneListeDecimales1"));
		JLabel label2 = new JLabel(MtgFrame.getString("paneListeDecimales2"));
		listeDec= new JList<String>();
		Vector<String> vec = new Vector<String>();
		for (int i = 0; i <= 12; i++) {
			vec.add(Integer.toString(i));
		}
		listeDec.setListData(vec);
    listeDec.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    listeDec.setLayoutOrientation(JList.VERTICAL);
    listeDec.setVisibleRowCount(5);
		listeDec.setSelectedIndex(nombreDecimalesInit);
		listeDec.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
    scrollpane = new JScrollPane(listeDec, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    JPanel paneLeft = new JPanel();
    paneLeft.setLayout(new BoxLayout(paneLeft, BoxLayout.Y_AXIS));
    paneLeft.add(label1);
    paneLeft.add(label2);
    setLayout(new FlowLayout());
    add(paneLeft);
    add(scrollpane);
    listeDec.ensureIndexIsVisible(listeDec.getSelectedIndex());
	}
	
	/**
	 * Fonction renvoyant le nombre de dcimales slectionn dans la liste
	 * @return
	 */
	public int nombreDecimales() {
		return listeDec.getSelectedIndex();
	}
}
