/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JRadioButton;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PanePreferencesBarreOutils extends PaneOptionsPreferences {
	private JRadioButton radioPetitesIcones, radioGrandesIcones;
	private JCheckBox checkColoredIcons;
	private ButtonGroup btnGroup;
	
	public PanePreferencesBarreOutils(MtgFrame frameInit) {
		super(frameInit);
		initComponents();
		radioPetitesIcones.setSelected(frame.pref_LittleIconSize);
		radioGrandesIcones.setSelected(!frame.pref_LittleIconSize);
		checkColoredIcons.setSelected(frame.pref_ColoredIcons);
	}
	
	private void initComponents() {
		checkColoredIcons = new JCheckBox(MtgFrame.getString("coloredIcons"));
		radioPetitesIcones = new JRadioButton(MtgFrame.getString("petitesIcones"));
		radioGrandesIcones = new JRadioButton(MtgFrame.getString("grandesIcones"));
		btnGroup = new ButtonGroup();
		btnGroup.add(radioPetitesIcones);
		btnGroup.add(radioGrandesIcones);
		setBorder(BorderFactory.createEmptyBorder(40, 5, 5, 0));
		setLayout(new GridBagLayout());
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 5;
		constraints.insets.top = 5;
		constraints.insets.left = 5;
		constraints.insets.right = 5;
		MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(radioPetitesIcones, constraints);
		MtgDlg.setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(radioGrandesIcones, constraints);
		MtgDlg.setConstraints(constraints, 0, 1, 2, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(checkColoredIcons, constraints);
	}
	
	@Override
	public void sauveDonnees() {
		frame.pref_LittleIconSize = radioPetitesIcones.isSelected();
		frame.pref_ColoredIcons = checkColoredIcons.isSelected();
	}

	@Override
	public String titreOnglet() {
		return MtgFrame.getString("ongletBarreOutils");
	}
	
	
}
