/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PanePreferencesPersonnalisationNiveau extends PaneOptionsPreferences {
	private OptionsPreferencesDlg dlg;
	private JCheckBox checkNiveauPersonnalise;
	private JPanel paneBas;
	private JLabel label1;
	private JCheckBox checkAffichageMesuresNiveau1;
	private JCheckBox checkAffichageMesuresNiveau2;
	private JCheckBox checkAffichageMesuresNiveau3;
	private JCheckBox checkAffichageMesuresNiveau4;
	private boolean checkAffichageMesuresNiveau1IsChecked;
	private boolean checkAffichageMesuresNiveau2IsChecked;
	private boolean checkAffichageMesuresNiveau3IsChecked;
	private boolean checkAffichageMesuresNiveau4IsChecked;
	

	// private boolean niveauPersonnalisePrec = frame.pref_NiveauPersonnalise;
	public PanePreferencesPersonnalisationNiveau(MtgFrame frameInit, OptionsPreferencesDlg dlgInit) {
		super(frameInit);
		dlg = dlgInit;
		checkAffichageMesuresNiveau1IsChecked = frame.pref_affichageMesuresNiveau[1];
		checkAffichageMesuresNiveau2IsChecked = frame.pref_affichageMesuresNiveau[2];
		checkAffichageMesuresNiveau3IsChecked = frame.pref_affichageMesuresNiveau[3];
		checkAffichageMesuresNiveau4IsChecked = frame.pref_affichageMesuresNiveau[4];
		initComponents();
	}
	
	private void initComponents() {
		checkNiveauPersonnalise = new JCheckBox(MtgDlg.getString("preferencesNiveauPersonnalise"));
		checkNiveauPersonnalise.setSelected(frame.pref_NiveauPersonnalise);
		checkNiveauPersonnalise.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				dlg.panePreferencesNiveau.initComponents(checkNiveauPersonnalise.isSelected());
				updateCheckBoxes();
			}
		});
		label1 = new JLabel();
		checkAffichageMesuresNiveau1 = new JCheckBox();
		checkAffichageMesuresNiveau1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				checkAffichageMesuresNiveau1IsChecked = checkAffichageMesuresNiveau1.isSelected();
			}
		});
		checkAffichageMesuresNiveau2 = new JCheckBox();
		checkAffichageMesuresNiveau2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				checkAffichageMesuresNiveau2IsChecked = checkAffichageMesuresNiveau2.isSelected();
			}
		});
		checkAffichageMesuresNiveau3 = new JCheckBox();
		checkAffichageMesuresNiveau3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				checkAffichageMesuresNiveau3IsChecked = checkAffichageMesuresNiveau3.isSelected();
			}
		});
		checkAffichageMesuresNiveau4 = new JCheckBox();
		checkAffichageMesuresNiveau4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				checkAffichageMesuresNiveau4IsChecked = checkAffichageMesuresNiveau4.isSelected();
			}
		});
		paneBas = new JPanel();
    paneBas.setLayout(new GridBagLayout());
    setLayout(new GridBagLayout());
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 100, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(checkAffichageMesuresNiveau4, constraints);
    MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(checkAffichageMesuresNiveau3, constraints);
    MtgDlg.setConstraints(constraints, 0, 2, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(checkAffichageMesuresNiveau2, constraints);
    MtgDlg.setConstraints(constraints, 0, 3, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(checkAffichageMesuresNiveau1, constraints);
    paneBas.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),MtgDlg.getString("preferencesAffichageMesures"),
    		TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.CENTER));
    
    MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 100, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);    
    add(label1, constraints);
    MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);    
    add(checkNiveauPersonnalise, constraints);
    MtgDlg.setConstraints(constraints, 0, 2, 1, 1, 0, 90, GridBagConstraints.NONE, GridBagConstraints.WEST);    
    add(paneBas, constraints);
		setBorder(BorderFactory.createEmptyBorder(10, 20, 10, 20));
		updateCheckBoxes();
	}
	
	@Override
	public void sauveDonnees() {
		frame.pref_NiveauPersonnalise = checkNiveauPersonnalise.isSelected();
		frame.pref_affichageMesuresNiveau[1] = checkAffichageMesuresNiveau1.isSelected();
		frame.pref_affichageMesuresNiveau[2] = checkAffichageMesuresNiveau2.isSelected();
		frame.pref_affichageMesuresNiveau[3] = checkAffichageMesuresNiveau3.isSelected();
		frame.pref_affichageMesuresNiveau[4] = checkAffichageMesuresNiveau4.isSelected();		
	}

	@Override
	public String titreOnglet() {
		// TODO Auto-generated method stub
		return MtgDlg.getString("ongletNiveauPersonnalise");
	}
	
	private void updateCheckBoxes() {
		String ch = MtgDlg.getString("ongletNiveau") + " : ";
		label1.setText(checkNiveauPersonnalise.isSelected()
				? ch + frame.descripteurNiveauPersonnalise[dlg.panePreferencesNiveau.niveauChoisi]
				: ch + frame.descripteurNiveauPredefini[dlg.panePreferencesNiveau.niveauChoisi]);
		ch = checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[1] : frame.descripteurNiveauPredefini[1];
		if (ch.length() < 100) {
			StringBuffer buf = new StringBuffer(ch);
			for (int i = 0; i < 100 - ch.length(); i++) buf.append(' ');
			ch = buf.toString();
		}
		checkAffichageMesuresNiveau1.setText(
				checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[1] : frame.descripteurNiveauPredefini[1]);
		checkAffichageMesuresNiveau1.setSelected(checkAffichageMesuresNiveau1IsChecked);
		checkAffichageMesuresNiveau2.setText(
				checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[2] : frame.descripteurNiveauPredefini[2]);
		checkAffichageMesuresNiveau2.setSelected(checkAffichageMesuresNiveau2IsChecked);
		checkAffichageMesuresNiveau3.setText(
				checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[3] : frame.descripteurNiveauPredefini[3]);
		checkAffichageMesuresNiveau3.setSelected(checkAffichageMesuresNiveau3IsChecked);
		/* Modifi version 4.6.3 pour que le titre du jpanel soit affich en entier
		checkAffichageMesuresNiveau4.setText(
				checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[4] : frame.descripteurNiveauPredefini[4]);
		 */
		String ch2 = checkNiveauPersonnalise.isSelected() ? frame.descripteurNiveauPersonnalise[4] : frame.descripteurNiveauPredefini[4];
		if (ch2.length() <= 100) {
			StringBuffer stb = new StringBuffer();
			for (int i = 0; i < 100 - ch2.length(); i++) stb.append(' ');
			ch2 = ch2 + stb;
		}
		checkAffichageMesuresNiveau4.setText(ch2);
		checkAffichageMesuresNiveau4.setSelected(checkAffichageMesuresNiveau4IsChecked);
	}
	
	@Override
	protected void paintComponent(Graphics arg0) {
		// TODO Auto-generated method stub
		updateCheckBoxes();
		super.paintComponent(arg0);
		
	}
	
	

}
