/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;

@SuppressWarnings("serial")
public class MtgOneColorButton extends JButton implements ActionListener, MouseListener {
  private MtgFrame frame;
  private static Insets insets = new Insets(2,2,2,2);
  public Color couleur; // la couleur du bouton
  private static Border margin = new EmptyBorder(1,1,1,1);

  /** Creates a new instance of MtgColorButton */
  public MtgOneColorButton(MtgFrame frameInit, Color couleurInit) {
		super(new ImageIcon(MtgFrame.class.getResource("images/BoutonCouleur.gif")));
    frame = frameInit;
    couleur = couleurInit;
    setMargin(insets);
    setBackground(frame.paneRightHaut.getBackground());
    addActionListener(this);
    addMouseListener(this);
    setToolTipText(MtgFrame.getString("choixCouleurDlg1"));
    setBorder(new CompoundBorder(BorderFactory.createRaisedBevelBorder(), margin));
  }
  
  
  public void actionPerformed(ActionEvent e) {
  	frame.paneTransparence.donneCouleurActive(couleur);
    frame.paneTransparence.donneCouleurBoutonTransparence(couleur);
  }
  
  @Override
  public void paint(Graphics g) {
  	// setSize(getPreferredSize());
  	setOpaque(false);
  	super.paint(g); // Pour que le rectangle de fond soit transparent
    Dimension rect = getSize();
		g.setColor(couleur);
    g.fillRect(2, 2, rect.width - 4, rect.height - 4);
	}
  
  public void mouseClicked(MouseEvent e) {
  }

  public void mouseEntered(MouseEvent e) {
    if (getCursor() != MtgFrame.defaultCursor) setCursor(MtgFrame.defaultCursor);
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
  }

  public void mouseReleased(MouseEvent e) {
  }  
  
}
