/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;
import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.*;
import javax.swing.border.EtchedBorder;
import actions.MtgAction;
/**
 *
 * @author Yves
 * Type de bouton associ aux outils. Possde un pointeur sur l'outil associ
 * Descend de JToggleButton et non de JButton car c'est  moi de grer l'activation
 * ou non d'un bouton. Par exemple, si l'utilisateur clique sur un outilm qui ne peut pas tre
 * activ, il faut le dsactiver et activer l'outil de capture.
 * JToggleButton permet au bouton de changer son tat par SetSelected(boolean)
 *
 */
@SuppressWarnings("serial")
public class MtgToggleButton extends JToggleButton {
  public MtgAction action;
  // private static Border margin = new EmptyBorder(1,1,1,1);
  // private static Insets insets = new Insets(1,1,1,1);
 
  /** Creates a new instance of JMtgButton */
  public MtgToggleButton(MtgAction actionInit) {
    super(actionInit);
    action = actionInit;
  	// setMargin(insets);
    setBorder(BorderFactory.createEtchedBorder());
  	setText("");
  }
  
  /**
   * Version 3.6.3 : Possibilit d'encadrer les icnes d'outil de construction
   * d'une couleur avec des couleurs spcifiques pour chaque type d'outil
   * @param actionInit
   * @param frameColor
   */
  public MtgToggleButton(MtgAction actionInit, Color frameColor) {
    super(actionInit);
    action = actionInit;
  	// setMargin(insets);
    setBorder(BorderFactory.createEtchedBorder());
  	setText("");
  	// Modifi version 4.6.2 pour que les cadres soient plus pais
  	/*
    if (action.frame.pref_ColoredIcons) setBorder(BorderFactory.createCompoundBorder(
    		BorderFactory.createEtchedBorder(EtchedBorder.RAISED),BorderFactory.createCompoundBorder(
      	BorderFactory.createLineBorder(frameColor), BorderFactory.createLineBorder(Color.white))));
      	*/
    if (action.frame.pref_ColoredIcons) setBorder(BorderFactory.createCompoundBorder(
    		BorderFactory.createEtchedBorder(EtchedBorder.RAISED),BorderFactory.createCompoundBorder(
      	BorderFactory.createLineBorder(frameColor, 2), BorderFactory.createLineBorder(Color.white))));

  }
  
  // Ajout version 4.7.0.1 pour que sous Mac on voie les icnes slectionnes
	@Override
	public void paint(Graphics arg0) {
		// TODO Auto-generated method stub
		super.paint(arg0);
		if (isSelected()) {
			Graphics2D pDC= (Graphics2D) arg0;
			pDC.setColor(Color.blue);
	    Composite originalComposite = pDC.getComposite();
	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.2f));
	    pDC.fillRect(0, 0, getWidth(), getHeight());
	    pDC.setComposite(originalComposite);
		}
	}
 
}
