/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;
import mathgraph32.MtgFrame;
import dialogs.ArgumentDlg;
import dialogs.MtgDlg;
import glob.Kernel;
import types.*;


public class CArgument extends CPartieReelle {
  
  /** Creates a new instance of CArgument */
  public CArgument() {
  }
  /* Constructeur pour clonage */
  public CArgument(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomCalculInit, CValeurDynamique complexeAssocieInit) {
    super(liste, impProtoInit, estElementFinalInit, nomCalculInit, complexeAssocieInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(complexeAssocie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb =  new CArgument(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, nomCalcul, (CValeurDynamique)(listeCible.get(ind1, CValeurDynamique.class)));
    return ptelb;
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NArgument;
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = complexeAssocie.existe;
    if (!existe) return;
    complexeAssocie.rendValeurComplexe(infoRandom, z1);
    existe = (z1.x != 0) || (z1.y != 0);
    if (existe) resultat = z1.argument(listeProprietaire.uniteAngle);
  }
  
  @Override
  public String infoPourHistorique() {
    String ch = getString("chinfo113") + " " + nom() + " " + getString("chinfo107") + " " + complexeAssocie.nom();
    if (existe) ch = ch + "\n" + getString("chinfo97") + Kernel.chaineNombre(resultat, 9);
    else ch = ch + "\n" + getString("ch18");
    return ch;
  }
  
  @Override
  public boolean modifiableParMenu() {
  	// Modifi version 3.5
  	// return true;
  	return !estElementFinal;
  }
  
   @Override
  public MtgDlg dialogueModification(MtgFrame frame) {
  	return new ArgumentDlg(frame, this, true);
  }
  
  
}
