/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;

import types.*;

/** Aucun objet du type bipoint ne devra jamais tre cr
 * Ce type d'objet sert pour dfinir des intersections de droites
 * et de cercles ou de cercles
 * */
public class CBipoint extends CElementBase {
  CPointDansBipoint point1;
  CPointDansBipoint point2;
  
  /** Creates new CBipoint */
  public CBipoint() {
    // Il faut crer les deux points maintenus par le Bipoint
    point1 = new CPointDansBipoint();
    point2 = new CPointDansBipoint();
  }
  
  public CBipoint(CListeObjets liste,CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
    // Il faut crer les deux points maintenus par le Bipoint
    point1 = new CPointDansBipoint();
    point2 = new CPointDansBipoint();
  }
 
  @Override
  public long getNature() {
    return NatureObjet.NBipoint;
  }
  
  //  pas de Constructeur pour clonage
  //public CBipoint (CPointAncetre point1Init, CPointAncetre point2Init) {
  //  point1 = point1Init;
  //  point2 = point2Init;
  //}
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    ((CBipoint) ptel).point1.existe = point1.existe;
    ((CBipoint) ptel).point1.x = point1.x;
    ((CBipoint) ptel).point1.y = point1.y;
    ((CBipoint) ptel).point2.existe = point2.existe;
    ((CBipoint) ptel).point2.x = point2.x;
    ((CBipoint) ptel).point2.y = point2.y;
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = (point1.existe) || (point2.existe);
  }
  
  // Renvoie chacun des deux lments dont le reprsente l'intersection
  CElementLigne elementAssocie(byte indice) {
    return null;
  }

  // Fonction dfinie pour la version 2.1 pour amliorer l'outil d'intersection
  // Renvoie true si le bipoint est dfini par la droite Droite
  // A redfinir pour les descendants
  boolean estDefiniPar(CDroiteAncetre droite)
  {
    return false;
  }
  // Fonction dfinie pour la version 2.1 pour amliorer l'outil d'intersection
  // Renvoie true si le bipoint est dfini par le cercle Cercle
  // A redfinir pour les descendants
  boolean estDefiniPar(CCercle cercle)
  {
    return false;
  }
  
  /**
   * Fonction renvoyant un pointeur vers le point rel dans la liste d'objets
   * propritaires correspondant au poinr d'intersection ind (1 ou 2)
   */
  
  public CPointLieBipoint pointReelDansListe(int ind) {
  	int inddeb = listeProprietaire.indexOf(this);
  	for (int i = inddeb + 1; i < listeProprietaire.size(); i++) {
  		CElementBase elb = listeProprietaire.get(i);
  		if (elb.getNature() == NatureObjet.NPoint) {
  			if (elb.getClass() == CPointLieBipoint.class) {
  				CPointLieBipoint ptlb = (CPointLieBipoint) elb;
  				if ((ptlb.ptBipoint == this) && (ptlb.indiceDansBipoint == ind)) return ptlb;
  			}
  		}
  	}
  	return null; // Normalement jamais
  }
}
