package objets;

import glob.Kernel;
import mathgraph32.MtgFrame;
import types.DimensionFenetre;
import types.NatureCalcul;
import dialogs.MtgDlg;
import dialogs.UniteYDlg;

/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
public class CUniteyRep extends CAbscisseOrigineRep {
	/**
	 * Constructeur pour serialisation
	 */
	public CUniteyRep() {
	}

  public CUniteyRep(CListeObjets liste, CImplementationProto impProtoInit,
  		boolean estElementFinalInit, String nomCalculInit, CRepere repInit) {
    // Inutile d'appeler le constructeur anctre vide
    super(liste, impProtoInit, estElementFinalInit, nomCalculInit, repInit);
  }
	
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(rep);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb =  new CUniteyRep(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, nomCalcul, (CRepere)(listeCible.get(ind1, CRepere.class)));
    return ptelb;
  }

  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NUniteyRep;
  }

  @Override
  public String infoPourHistorique() {
    String ch =  getString("chinfo181") + " " + nomCalcul + " " + getString("chinfo32") + " " + rep.nom();
    if (existe) ch = ch + "\n" + getString("chinfo97") + " " + Kernel.chaineNombre(abscisseOrigine, 16);
    else ch = ch + "\n" + getString("ch18");
    return ch;        
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	existe = rep.existe;
  	abscisseOrigine = rep.unitey;
  }
  
  
  @Override
  public MtgDlg dialogueModification(MtgFrame frame) {
  	return new UniteYDlg(frame, this, true);
  }

}
