/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import java.util.ListIterator;
import objets.*;
import types.*;
import mathgraph32.MtgFrame;

/**
 *
 * @author Yves
 */
public class OutilCapture extends Outil{
  
  /** Creates a new instance of OutilCapture */
  public OutilCapture(MtgFrame frameInit) {
    super(frameInit, false);
  }
    
  /** Appel lorsque l'outil est slectionn */
  @Override
  public void select() {
    super.select();
    CMathGrafDoc doc = frame.cadreActif().document;
    long nature = NatureObjet.NPointMobile;
    if (!doc.marquesAnglesFigees) nature = nature | NatureObjet.NMarqueAngle;
    // Modification version 4.5
    // if (!doc.affichagesFiges) nature = nature | NatureObjet.NAffichageLieAPoint;
    if (!doc.affichagesFiges) nature = nature | NatureObjet.NAffichageLieAPoint | NatureObjet.NLieuObjet;
    
    frame.outilPointageCapture.designationDe(nature);
    //On ajoute  la liste d'exclusion de dsignation tous les points
    // mobiles punaiss
    CListeObjets list = frame.cadreActif().listePr;
    ListIterator<CElementBase> li = list.listIterator();
    while(li.hasNext()) {
      CElementBase elb = li.next();
      long nat = elb.getNature();
      if ((nat & NatureObjet.NPointMobile) != 0) {
        if (!((CPointAncetrePointsMobiles) elb).estLibre()) 
          frame.listeExclusionDesignation.add(elb);
      }
    }
    frame.indication(getString("capture1"));
    frame.outilPointageActif = frame.outilPointageCapture;
    frame.outilPointageActif.reset();
}
  
}
