/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CAffichageLieAPoint;
import objets.CCommentaire;
import objets.CEditeurFormule;
import objets.CListeObjets;
import types.NatureCalcul;
import types.StyleEncadrement;
import dialogs.EditeurFormuleDlg;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilEditeurFormule extends OutilAffichageValeur {
	
  /** Creates a new instance of OutilPtLib */
  public OutilEditeurFormule(MtgFrame frameInit) {
    super(frameInit);
  }

  @Override
  public void creeObjet() {
    int x = pointDesigne.x;
    int y = pointDesigne.y;
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    // Avant l'affichage du dialogue on cre un message qui sera ajout  la liste des objets clignotants
    // pour matrialiser l'emplacement de l'affichage
    CCommentaire com = new CCommentaire(liste, null, false, frame.couleurActive(), x, y, 0d, 0d, false, null, 2,
    		StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, getString("ch80"),
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    com.positionne(false, frame.cadreActif().dimf);
    ajouteClignotementDe(com);
    resetClignotement();
    CEditeurFormule affval = new CEditeurFormule(liste, null, false, frame.couleurActive(),
    		x, y, 0d, 0d, false, frame.pref_IndiceTaillePoliceAffichages, StyleEncadrement.Sans,
    		false, frame.cadreActif().couleurFondAffichage, null, "", 12, true, "=", false, true, true);
    frame.indication("");
    EditeurFormuleDlg dlg = new EditeurFormuleDlg(frame, affval, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
	    if (frame.ajouteElementAvecVerification(affval)) {
	    	annuleClignotement();
	      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil155"));
	      affval.positionne(cadre.infRand, cadre.dimf);
	      // Le mtgFormulaEditor doit tre affich  ce niveau
	      affval.mtgFormulaEditor.setPositionOnInternaleFrame();
	      cadre.repaintFigureAvecCalcul();
	    }
    }
    annuleClignotement();
    select();
  }

  @Override
  public boolean activationValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		return (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NCalculOuFonctionParFormule)!=0);
  }
}
