/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Cursor;
import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CAffichageLieAPoint;
import objets.CCommentaire;
import objets.CElementGraphique;
import objets.CImage;
import objets.CListeObjets;
import types.StyleEncadrement;
import dialogs.ImageDlg;
import entreesSorties.MathGraphDataOutputStream;

public class OutilImageLibre extends Outil {

	public OutilImageLibre(MtgFrame frameInit) {
		super(frameInit, true);
	}

	@Override
	public Cursor curseurUtilise() {
		return MtgFrame.cornerCursor;
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageClic;
		frame.indication(getString("image1"));
	}

	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		int x = pointClique.x;
		int y = pointClique.y;
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		// Avant l'affichage du dialogue on cre un message qui sera ajout  la
		// liste des objets clignotants
		// pour matrialiser l'emplacement de l'affichage
		CCommentaire comClignotant = new CCommentaire(liste, null, false, frame.couleurActive(), x, y, 0d, 0d,
				false, null, 2, StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, getString("ch80"),
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    comClignotant.positionne(false, frame.cadreActif().dimf);
		ajouteClignotementDe(comClignotant);
		resetClignotement();
		CImage image = new CImage(liste, null, false, frame.couleurActive(), x, y, 0d, 0d,
				false, null, 2, StyleEncadrement.Sans, false, cadre.couleurFond, MathGraphDataOutputStream.nat_png, null,
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
		frame.indication("");
		ImageDlg dlg = new ImageDlg(frame, image, false);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
		if (dlg.retourOK()) {
			annuleClignotement();
			if (frame.ajouteElementAvecVerification(image)) {
				frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil92"));
				frame.cadreActif().repaintFigureAvecCalcul();
			}
			frame.activeOutilCapture();
		} else {
			annuleClignotement();
			frame.activeOutilCapture();
		}
	}
	
	/* Abandonn version 4.4 car les images sont maintenant enregistres dans le flux de donnes
  @Override
	public boolean activationValide() {
		// Pour ajouter une image, le document doit avoir
		// t enregistr
		return (frame.cadreActif().document.path.length() != 0);
	}

	@Override
	public String messageActivationNonValide() {
		return getString("messageFichierNonEnregistre");
	}
	*/
	
}
