/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import mathgraph32.MtgFrame;
import objets.CAffichageLieAPoint;
import objets.CLatex;
import objets.CListeObjets;
import types.StyleEncadrement;
import dialogs.LatexDlg;

public class OutilLatexLiePoint extends OutilParPoint {
	/** Constructeur */
	public OutilLatexLiePoint(MtgFrame frameInit) {
		super(frameInit);
	}

  @Override
  public void creeObjet() {
  	CListeObjets liste = frame.cadreActif().listePr;
    // Avant l'affichage du dialogue on cre un message qui sera ajout  la liste des objets clignotants
    // pour matrialiser l'emplacement de l'affichage
    CLatex latexClignotant = new CLatex(liste, null, false, frame.couleurActive(), 0d, 0d, 0d, 6d, false, point, 2,
    		StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, "\\text{" + getString("ch80") + "}",
				CAffichageLieAPoint.alignementHorizontalCentre, CAffichageLieAPoint.alignementVerticalHaut);
    latexClignotant.positionne(false, frame.cadreActif().dimf);
    ajouteClignotementDe(latexClignotant);
    resetClignotement();  	
    CLatex com = new CLatex(liste, null, false, frame.couleurActive(),
    		0d, 0d, 0d, 6d, false, point, frame.pref_IndiceTaillePoliceAffichages, StyleEncadrement.Sans, false, frame.cadreActif().couleurFondAffichage, null,
				CAffichageLieAPoint.alignementHorizontalCentre, CAffichageLieAPoint.alignementVerticalHaut);
    LatexDlg dlg = new LatexDlg(frame, com, false, latexClignotant);
    frame.cadreActif().videDesignation();
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
	    if (frame.ajouteElementAvecVerification(com)) {
	    	annuleClignotement();
	      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil140"));
	      frame.cadreActif().repaintFigureAvecCalcul();
	    }
    }
    annuleClignotement();
    select();
  }
  
  @Override
  public String chaineIndication(int indEtape) {
    switch(indEtape) {
      case 1 : return getString("latexLiePoint1");
      default: return "";
    }
  }
}
