package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CMinFonc;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.MaximumMinimumDlg;

public class OutilMinimum extends Outil {
  public OutilMinimum(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    CValeurAssocieeAVariable vala = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable valb = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable vale = new CValeurAssocieeAVariable(liste, 0);
    CMinFonc min = new CMinFonc(liste, null, false, "", null, vala, valb, vale);    
    MaximumMinimumDlg dlg = new MaximumMinimumDlg(frame, min, false, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(min))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil148"));    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalcul(NatureCalcul.NFonction) != 0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeFonction");
	}	
  
}
