/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CCommentaire;
import objets.CElementGraphique;
import types.NatureObjet;

public class OutilReclassementDebutObjetGraphique extends Outil {
	public OutilReclassementDebutObjetGraphique(MtgFrame frameInit) {
		super(frameInit, true);
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageCre;
		frame.outilPointageActif.designationDe(NatureObjet.NToutObjet);
		frame.indication(getString("reclassementDebutObjetGraphique1"));
	}
	
	@Override
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		MtgInternalFrame cadre = frame.cadreActif();
		if (cadre.listePr.reclasseVersDebutAvecDependants(elg)) {
			frame.dialogueInformation(getString("reclassementDebutObjetGraphique2"));
			if (elg.estDeNature(NatureObjet.NCommentaireOuLatex)) 
				((CCommentaire)elg).metAJour(); // Ajout version 4.6 pour que les dpendances de commentaires et laTeX dynamiques soient remis  jour			
			cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil102"));
			cadre.repaintFigureAvecCalcul();
	    cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
		}
		else frame.dialogueAvertissement(getString("reclassementDebutObjetGraphique3"));
		frame.activeOutilCapture();
	}
}
